Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 47050)
+++ channels/chan_sip.c	(working copy)
@@ -13864,27 +13864,31 @@
 		pbx_builtin_setvar_helper(current.chan2, "SIPTRANSFER", "yes");
 		/* One for the new channel */
 		pbx_builtin_setvar_helper(current.chan2, "_SIPTRANSFER", "yes");
-		if (p->refer->referred_by)
+		/* Attended transfer to remote host, prepare headers for the INVITE */
+		if (p->refer->referred_by) {
+			pbx_builtin_setvar_helper(current.chan2, "SIPTRANSFER_REFERER", p->refer->referred_by);
 			pbx_builtin_setvar_helper(current.chan2, "_SIPTRANSFER_REFERER", p->refer->referred_by);
-		if (p->refer->referred_by)
-		/* Attended transfer to remote host, prepare headers for the INVITE */
-		pbx_builtin_setvar_helper(current.chan2, "_SIPTRANSFER_REFERER", p->refer->referred_by);
+		}
 	}
-	/* Generate an URI-encoded string */
+	/* Generate a Replaces string to be used in the INVITE during attended transfer */
 	if (p->refer->replaces_callid && !ast_strlen_zero(p->refer->replaces_callid)) {
 		char tempheader[BUFSIZ];
-		char tempheader2[BUFSIZ];
 		snprintf(tempheader, sizeof(tempheader), "%s%s%s%s%s", p->refer->replaces_callid, 
 				p->refer->replaces_callid_totag ? ";to-tag=" : "", 
 				p->refer->replaces_callid_totag, 
 				p->refer->replaces_callid_fromtag ? ";from-tag=" : "",
 				p->refer->replaces_callid_fromtag);
-
-		/* Convert it to URL encoding, also convert reserved strings */
+		if (current.chan2)
+			pbx_builtin_setvar_helper(current.chan2, "_SIPTRANSFER_REPLACES", tempheader);
+		/* This is wrong - uri encoding is what we want to do if we are dealing with a uri.
+		   Here we storing the callid, to-tag, and from-tag in a string to be used in
+		   INVITE Replace: header during the attended transfer we are participating in.
+		*/
+		/*
 		ast_uri_encode(tempheader, tempheader2, sizeof(tempheader2), 1);
-
 		if (current.chan2)
 			pbx_builtin_setvar_helper(current.chan2, "_SIPTRANSFER_REPLACES", tempheader2);
+		*/
 	}
 	/* Must release lock now, because it will not longer
     	   be accessible after the transfer! */
@@ -13895,8 +13899,17 @@
 	/* Connect the call */
 
 	/* FAKE ringing if not attended transfer */
+	/* This seems wrong as the target it is not Ringing at this point.
+	   We will not know if it rang until after the ast_async_goto
+	   below returns, at which point it will be too late to report Ringing.
+	   While it would be nice if we new the status and could notify with
+	   regard to it, there is no requirement to report Ringing, so why
+	   FAKE it and be wrong about it some of the time.
+	*/
+	/*
 	if (!p->refer->attendedtransfer)
-		transmit_notify_with_sipfrag(p, seqno, "183 Ringing", FALSE);
+		transmit_notify_with_sipfrag(p, seqno, "183 Ringing", FALSE); 
+	*/
 		
 	/* For blind transfer, this will lead to a new call */
 	/* For attended transfer to remote host, this will lead to
@@ -13910,7 +13923,8 @@
 		   * Let the new channel masq into this channel
 		   Please add that code here :-)
 		*/
-		transmit_response(p, "202 Accepted", req);
+		/* We sent this already above, no need to do it twice */
+		/* transmit_response(p, "202 Accepted", req); */
 		p->refer->status = REFER_FAILED;
 		transmit_notify_with_sipfrag(p, seqno, "503 Service Unavailable (can't handle one-legged xfers)", TRUE);
 		ast_clear_flag(&p->flags[0], SIP_GOTREFER);	
